%donald
viewport heaparr
line Lline, Rline, rangeline
point LlineT, LlineB, RlineT, RlineB, Firstpt, Lastpt
Lline = [LlineT, LlineB]
Rline = [RlineT, RlineB]
rangeline = [Firstpt, Lastpt]
%eden
eltarr is [_elt1, _elt2, _elt3, _elt4, _elt5, _elt6, _elt7];
_RlineT is vector_add(eltarr[Rmark], cart(0,25));
_RlineB is vector_add(eltarr[Rmark], cart(0,15));
_LlineT is vector_add(eltarr[Lmark], cart(0,25));
_LlineB is vector_add(eltarr[Lmark], cart(0,15));
_Firstpt is vector_add(eltarr[first], cart(0,20));
_Lastpt is vector_add(eltarr[last], cart(0,20));

Rmark is first;
Lmark is last;

/* this file contains a general-purpose visual device that includes
	a horizontal line to depict a range of elements from the
	array being sorted (rangeline), together with 2 vertical
	lines to point to significant locations (Lline, Rline)
	The dimensions and locations of these lines are determined by four
	indices of array elements:
		first, last determine the ends of rangeline
		Lmark and Rmark determine the location of Lline and Rline
*/

/* as set above: Rmark and Lmark determine the range line for selction sort
	to set up range line and travelling pointers for bubblesort:

	Rmark is 7-bs_pass+1;
	Lmark is bs_pos;
	first = 1;
	last is Rmark;
*/
