/* list to show the empirical modellers, so we can refuse entry to all
others! */

allowcustomers = [0,0,1,1,1,1,0,0,1,0];

/* Now the routines for accepting/rejecting a new booking */
       
func choosetable
{  
para name,people,arrivetime;
auto tableno,i,j;
  
  possibletables = [];
  for (i=1; i<=R_numberoftables; i++) {append possibletables,i;}
/* check capacity of table with people in party*/
  people = int(people); arrivetime=int(arrivetime);

  for (i=1; i<=R_numberoftables; i++) {
    writeln(R_tablecapacity[i]," ",people," ",possibletables[i],i);
    if (R_tablecapacity[i] < people) {possibletables[i] =
-1;writeln("fred");}else {writeln("wilma");}
  }
    
  writeln(possibletables);
/* now check we can fit their booking in where they want */
  for (i=1; i<=R_numberoftables; i++)
  {
    for (j=1; j<=booking_list#; j++)
    {  
      if ((booking_list[j][2]==i)&&(booking_list[j][5]==FALSE)) /*i.e not
cancelled */
      {
        if
((arrivetime>booking_list[j][4]+booking_length)||(arrivetime+booking_length<booking_list[j][4]))
        {
           /* we're ok with this as it fits into the slot */
        } else {possibletables[i] = -1;}
      }
    }
  }
/* possible tables now shows a list which includes some -1's. */
  writeln("Possible tables are ",possibletables);
  resulttables = [];
  for (i=1; i<=R_numberoftables; i++) {if (possibletables[i]>0) {append
resulttables,i;}}
  writeln(resulttables);

  for (i=1; i<=possible_customers#; i++)
  {
    writeln(possible_customers[i],name);
    if (possible_customers[i]==name) {j= i;}
  }
  if (allowcustomers[j]==0) 
  { resulttables = [];
   writeln("Non Empirical Modeller! You cannot dine in our restaurant!");
  } /*refuse all non EM ers */


  if (resulttables#!=0)
  {
/*    tableno = random(resulttables#)+1;
    writeln("Allocated table number ",resulttables[tableno]);
    return resulttables[tableno];
*/

/* Algorithm - Imagine putting the booking onto each of the available tables
at that time. Now look for the minimum amount of time wasted either side of
that booking on that table. Now minimise this over all tables and you will
have the table that is most appropriate as it creates the least table
wastage */
/* NOTE - It still doesn't consider the relative merits of table size. If
you have 2 people turn up and there will be 6 mins wastage on a table for 2
and a 5 min wastage on a table for 4 then it will choose the table for 4.
This invokes the big issue of the importance of capacity vs unused time,
which is the most important and by how much, does it vary from restaurant
to restaurant. Does it vary on the amount you spend, the lengths of the
bookings etc?? */

    m = 1000; /* holds the minimum time */
    t = 0; /* the table for that minimum time */

    for (i=1; i<=resulttables#;i++) 
    {
      for (j=1; j<=booking_list#; j++)
      {
writeln(i,j);
	/* customer not cancelled and correct table */
	if ((booking_list[j][5]==FALSE)&&(booking_list[j][2]==resulttables[i]))
        {
	  /* will be either after or before the slot */
	  if (booking_list[j][4]<arrivetime) /* i.e before */
	  {
  	    if (arrivetime-(booking_list[j][4]+booking_length)<m) 
   	    {
	      m = arrivetime-(booking_list[j][4]+booking_length);
	      t = resulttables[i];
	    }
	  } else
	  {
	    if (booking_list[j][4]-(arrivetime+booking_length)<m)
	    {
	      m = booking_list[j][4]-(arrivetime+booking_length);
	      t = resulttables[i];
	    }
	  }
	}
      }    
    }
    return t;
  } else {tableno=0;return tableno;} 
}  
    

