/* procedure creates all the definitions required to draw, maintain and
handle an arbitrary window for the data explorer display */

proc createwin 

{
para wname,wwidth,wheight,wbasex,wbasey,wbw,wtitle;
auto temp,temp2,temp3;

/* first execute creates the window background and display part */

  execute("%scout
	   integer "//str(wname)//"width,"//str(wname)//"height,"//str(wname)//"bw,"//str(wname)//"scrollheight,"//str(wname)//"titleheight;
	   "//str(wname)//"width = "//str(wwidth)//";
	   "//str(wname)//"height = "//str(wheight)//";
	   "//str(wname)//"bw = "//str(wbw)//";
	   "//str(wname)//"scrollheight = 20;
	   "//str(wname)//"titleheight = 15;
	   point "//str(wname)//"_base;
	   "//str(wname)//"_base = {"//str(wbasex)//","//str(wbasey)//"};      

	   window "//str(wname)//"disp = {
                  type: DONALD,
		  box: ["//str(wname)//"_base,"//str(wname)//"_base+{"//str(wname)//"width,"//str(wname)//"height}],
                  pict: \""//str(wname)//"DISPLAY\",
                  xmin: 0,
                  xmax: 100,
                  ymin: 0,
                  ymax: 100,
                  bgcolor : \"grey\",
                  bdcolor : borderColor,
                  border: 1,
                  relief: \"raised\",
                  sensitive : MOTION
	   };   
  
 
	   window "//str(wname)//"Back = {
        	  type: TEXT,
        	  string: \"\",
		  frame: (["//str(wname)//"_base-{"//str(wname)//"bw,15+"//str(wname)//"bw},"//str(wname)//"_base+{"//str(wname)//"bw+"//str(wname)//"width,"//str(wname)//"bw+"//str(wname)//"height+"//str(wname)//"scrollheight}]),
        	  bgcolor: borderColor,
        	  border: 1
	   };
	  ");

/* creates the window title in Donald */

  execute("%donald
	   viewport "//str(wname)//"TITLE
	   label "//str(wname)//"string	   
	   "//str(wname)//"string = label(\""//str(wtitle)//"\",{"//str(wname)//"width! div 2,"//str(wname)//"titleheight! div 2})
	  ");

/* puts the window title in a scout window */

  execute("%scout
                  
	   window "//str(wname)//"TitleBar = {
             type: DONALD,
             pict : \""//str(wname)//"TITLE\",
             box: ["//str(wname)//"_base-{0,15}, "//str(wname)//"_base+{"//str(wname)//"width,0}],
             xmin : 0,
             ymin : 0,
             xmax : "//str(wname)//"width,
             ymax : "//str(wname)//"titleheight, 
             border: 1,
             fgcolor: \"white\",
             bgcolor: borderColor,
             sensitive: MOTION
	   };

	  ");

  execute("%scout
	   integer "//str(wname)//"HScrollBar_left,"//str(wname)//"HScrollBar_right,"//str(wname)//"HScrollBar_size;
	   "//str(wname)//"HScrollBar_left = 0;
	   "//str(wname)//"HScrollBar_size = "//str(wname)//"HScrollBar_right-"//str(wname)//"HScrollBar_left;
	   "//str(wname)//"HScrollBar_right = "//str(wname)//"width;
  
	  window "//str(wname)//"HorizontalScrollBarBack = {
            type : DONALD,
            box: ["//str(wname)//"_base+{0,"//str(wname)//"height+5},"//str(wname)//"_base+{0,"//str(wname)//"height-1}+{"//str(wname)//"width,"//str(wname)//"scrollheight}],
            pict : \""//str(wname)//"HSCROLLBAR\",
            xmin : 0,
            ymin : 0,
            xmax : 100,
            ymax : 100,
            bgcolor : \"grey\",
            bdcolor : borderColor,
            border : 1,
            relief : \"sunken\",
            sensitive : ON
	  };
        
	  window "//str(wname)//"HorizontalScrollBarMain = {
            type : DONALD,
	    box:["//str(wname)//"_base+{"//str(wname)//"HScrollBar_left,"//str(wname)//"height+7},"//str(wname)//"_base+{0,"//str(wname)//"height-3}+{"//str(wname)//"HScrollBar_right,"//str(wname)//"scrollheight}],
            pict : \""//str(wname)//"HSCROLLBAR\",
            xmin : 0,
            ymin : 0,
            xmax : "//str(wname)//"HScrollBar_size,
            ymax : 100,
            bgcolor : \"grey\",
            bdcolor : borderColor,
            border : 1,
            relief : \"raised\",
            sensitive : MOTION
          };

	  window "//str(wname)//"HorizontalScrollBarLeftwidget = {
            type : DONALD,
	    box:["//str(wname)//"_base+{"//str(wname)//"HScrollBar_left,"//str(wname)//"height+8},"//str(wname)//"_base+{0,"//str(wname)//"height-4}+{"//str(wname)//"HScrollBar_left+3,"//str(wname)//"scrollheight}],
            pict : \""//str(wname)//"HSCROLLBARLEFTWIDGET\",
            xmin : 0,  
            ymin : 0,
            xmax : 3,
            ymax : 100,
            bgcolor : \"black\",
            bdcolor : borderColor,
            border : 1,
            relief : \"raised\",
            sensitive : MOTION
	  };
        
	  window "//str(wname)//"HorizontalScrollBarRightwidget = {
            type : DONALD,
	    box:["//str(wname)//"_base+{"//str(wname)//"HScrollBar_right-3,"//str(wname)//"height+8},"//str(wname)//"_base+{0,"//str(wname)//"height-4}+{"//str(wname)//"HScrollBar_right,"//str(wname)//"scrollheight}],
            pict : \""//str(wname)//"HSCROLLBARRIGHTWIDGET\",
            xmin : 0,  
            ymin : 0,
            xmax : 3,
            ymax : 100,
            bgcolor : \"black\",
            bdcolor : borderColor,
            border : 1,
            relief : \"raised\",
            sensitive : MOTION
	  };

	  ");

/* create the display window */

  execute("%scout
	   display "//str(wname)//"window =<"//str(wname)//"TitleBar/"//str(wname)//"disp/"//str(wname)//"HorizontalScrollBarLeftwidget/"//str(wname)//"HorizontalScrollBarRightwidget/"//str(wname)//"HorizontalScrollBarMain/"//str(wname)//"HorizontalScrollBarBack/"//str(wname)//"Back>;
	  ");

/* Now add the new display to the screen list display */

  temp = symboldetail("screen")[3];
  temp2= substr(temp,1,temp#-1);
  temp3 =strcat(" // ",wname,"window");
  temp4 = strcat(temp2,temp3,";");
  execute("screen is "//str(temp4)//" ");


}


/* this procedure assumes we have an empty screen and is passed the data list to
display, a list
containing the titles for each of the windows and the starting window default
sizes. The display is
created as a single step and the number of displays created is equal to the number
of elements in each
data list */
           
proc displaylist
{
para l,titles,defwid,defhei;
auto i,s;

/* create the windows */
  for (i=1; i<=l[1]#; i++) 
  {
    s = strcat("win",str(i));
    createwin(s,defwid,defhei,20,20+((i-1)*(defhei+60)),5,titles[i]);
  }  
  
/* add the data items */
autocalc = 0;
  for (i=1; i<=l#; i++)
  {
    adddataitem(l[i]);
  }
autocalc = 1;
}

