%scout

integer clockwinScale;
point clockwinNW;
point clockwinSE;
point clockwinPos;

#i challenge anyone to understand why 30 & 370 are used...[CR]

window clockwin = {
    type: DONALD
    box: [clockwinNW, clockwinSE]
    pict: "CLOCK"
    xmin: 30
    ymin: 30
    xmax: 370
    ymax: 370
    bgcolor: "white"
    border: 1
    sensitive : ON
};

clockwinScale = 2;
clockwinPos = {(screen_width / 2) - (100*clockwinScale), 150};

point clockwinNW = clockwinPos + {20 * clockwinScale, 20 * clockwinScale};
point clockwinSE = clockwinPos + {180 * clockwinScale, 180 * clockwinScale};
#display screen = <clockwin>;

%donald
viewport CLOCK

openshape clock

within clock {
    real sixthpi
    line eleven, ten, nine, eight, seven, six, five, four, three, two, one
    line noon
    point centre
    real radius
    circle edge

    sixthpi = 0.523599
    radius = 150.0
    eleven = rot(noon, centre, -11 * sixthpi)
    ten = rot(noon, centre, -10 * sixthpi)
    nine = rot(noon, centre, -9 * sixthpi)
    eight = rot(noon, centre, -8 * sixthpi)
    seven = rot(noon, centre, -7 * sixthpi)
    six = rot(noon, centre, -6 * sixthpi)
    five = rot(noon, centre, -5 * sixthpi)
    four = rot(noon, centre, -4 * sixthpi)
    three = rot(noon, centre, -3 * sixthpi)
    two = rot(noon, centre, -2 * sixthpi)
    one = rot(noon, centre, -sixthpi)
    noon = [centre+{0, 0.9*radius}, centre+{0,radius}]
    centre = {200, 200}
    edge = circle(centre, radius)

  line minHand, hourHand
  real minAngle, hourAngle 
  int t
  minAngle = (pi div 2.0) - float (t mod 60) * (pi div 30.0)
  hourAngle = (pi div 2.0) - float (t mod 720) * (pi div 360.0) 

  minHand = [centre + {0.75*radius @ minAngle}, centre]
  hourHand = [centre + {0.5*radius @ hourAngle}, centre]
  centre = {200, 200}

}

# clock/t is a donald int variable
# representing time elapsed in minutes
# from midnight (1440 per day)

%eden
A_clock_edge is "outlinecolor=black";
A_clock_noon is "color=black";
A_clock_one is "color=black";
A_clock_two is "color=black";
A_clock_three is "color=black";
A_clock_four is "color=black";
A_clock_five is "color=black";
A_clock_six is "color=black";
A_clock_seven is "color=black";
A_clock_eight is "color=black";
A_clock_nine is "color=black";
A_clock_ten is "color=black";
A_clock_eleven is "color=black";
