/* procedure creates all the definitions required to draw, maintain and
handle an arbitrary window for the data explorer display */

/* this version is --specifically-- for the spreadsheet demo as it writes 
out to a different screen.. May 22, 2002 */

proc createwin 

{
para wname,wwidth,wheight,wbasex,wbasey,wbw,wtitle;
auto temp,temp2,temp3;
writeln("win name is ",wname," ",wname#);	

if (substr(wname,1,3)=="win") 
 {
  execute("append winlist,\""//str(wname)//"\";");
  execute("append viewportlist,\""//str(wname)//"DISPLAY\";");
 } else {writeln("NAH");}

/* first execute creates the window background and display part */

  execute("%scout
	   integer "//str(wname)//"width,"//str(wname)//"height,"//str(wname)//"bw,"//str(wname)//"scrollheight,"//str(wname)//"titleheight;
	   "//str(wname)//"width = "//str(wwidth)//";
	   "//str(wname)//"height = "//str(wheight)//";
	   "//str(wname)//"bw = "//str(wbw)//";
	   "//str(wname)//"scrollheight = 20;
	   "//str(wname)//"titleheight = 15;
	   point "//str(wname)//"_base;
	   "//str(wname)//"_base = {"//str(wbasex)//","//str(wbasey)//"};      

	   window "//str(wname)//"disp = {
                  type: DONALD,
		  box: ["//str(wname)//"_base,"//str(wname)//"_base+{"//str(wname)//"width,"//str(wname)//"height}],
                  pict: \""//str(wname)//"DISPLAY\",
                  xmin: 0,
                  xmax: 100,
                  ymin: 0,
                  ymax: 100,
                  bgcolor : \"grey\",
                  bdcolor : borderColor,
                  border: 1,
                  relief: \"raised\",
                  sensitive : ON+MOTION
	   };   
  
 
	   window "//str(wname)//"Back = {
        	  type: TEXT,
        	  string: \"\",
		  frame: (["//str(wname)//"_base-{"//str(wname)//"bw,15+"//str(wname)//"bw},"//str(wname)//"_base+{"//str(wname)//"bw+"//str(wname)//"width,"//str(wname)//"bw+"//str(wname)//"height+"//str(wname)//"scrollheight}]),
        	  bgcolor: borderColor,
        	  border: 1
	   };
	  ");

/* creates the window title in Donald */

  execute("%donald
	   viewport "//str(wname)//"TITLE
	   label "//str(wname)//"string	   
	   "//str(wname)//"string = label(\""//str(wtitle)//"\",{"//str(wname)//"width! div 2,"//str(wname)//"titleheight! div 2})
	  ");

/* puts the window title in a scout window */

  execute("%scout
                  
	   window "//str(wname)//"TitleBar = {
             type: DONALD,
             pict : \""//str(wname)//"TITLE\",
             box: ["//str(wname)//"_base-{0,15}, "//str(wname)//"_base+{"//str(wname)//"width,0}],
             xmin : 0,
             ymin : 0,
             xmax : "//str(wname)//"width,
             ymax : "//str(wname)//"titleheight, 
             border: 1,
             fgcolor: \"white\",
             bgcolor: borderColor,
             sensitive: ON+MOTION
	   };

	  ");

  execute("%scout
	   integer "//str(wname)//"HScrollBar_left,"//str(wname)//"HScrollBar_right,"//str(wname)//"HScrollBar_size;
	   "//str(wname)//"HScrollBar_left = 0;
	   "//str(wname)//"HScrollBar_size = "//str(wname)//"HScrollBar_right-"//str(wname)//"HScrollBar_left;
	   "//str(wname)//"HScrollBar_right = "//str(wname)//"width;
  
	  window "//str(wname)//"HorizontalScrollBarBack = {
            type : DONALD,
            box: ["//str(wname)//"_base+{0,"//str(wname)//"height+5},"//str(wname)//"_base+{0,"//str(wname)//"height-1}+{"//str(wname)//"width,"//str(wname)//"scrollheight}],
            pict : \""//str(wname)//"HSCROLLBAR\",
            xmin : 0,
            ymin : 0,
            xmax : 100,
            ymax : 100,
            bgcolor : \"grey\",
            bdcolor : borderColor,
            border : 1,
            relief : \"sunken\",
            sensitive : ON+MOTION
	  };
        
	  window "//str(wname)//"HorizontalScrollBarMain = {
            type : DONALD,
	    box:["//str(wname)//"_base+{"//str(wname)//"HScrollBar_left,"//str(wname)//"height+7},"//str(wname)//"_base+{0,"//str(wname)//"height-3}+{"//str(wname)//"HScrollBar_right,"//str(wname)//"scrollheight}],
            pict : \""//str(wname)//"HSCROLLBAR\",
            xmin : 0,
            ymin : 0,
            xmax : "//str(wname)//"HScrollBar_size,
            ymax : 100,
            bgcolor : \"grey\",
            bdcolor : borderColor,
            border : 1,
            relief : \"raised\",
            sensitive : ON+MOTION
          };

	  window "//str(wname)//"HorizontalScrollBarLeftwidget = {
            type : DONALD,
	    box:["//str(wname)//"_base+{"//str(wname)//"HScrollBar_left,"//str(wname)//"height+8},"//str(wname)//"_base+{0,"//str(wname)//"height-4}+{"//str(wname)//"HScrollBar_left+3,"//str(wname)//"scrollheight}],
            pict : \""//str(wname)//"HSCROLLBARLEFTWIDGET\",
            xmin : 0,  
            ymin : 0,
            xmax : 3,
            ymax : 100,
            bgcolor : \"black\",
            bdcolor : borderColor,
            border : 1,
            relief : \"raised\",
            sensitive : ON+MOTION
	  };
        
	  window "//str(wname)//"HorizontalScrollBarRightwidget = {
            type : DONALD,
	    box:["//str(wname)//"_base+{"//str(wname)//"HScrollBar_right-3,"//str(wname)//"height+8},"//str(wname)//"_base+{0,"//str(wname)//"height-4}+{"//str(wname)//"HScrollBar_right,"//str(wname)//"scrollheight}],
            pict : \""//str(wname)//"HSCROLLBARRIGHTWIDGET\",
            xmin : 0,  
            ymin : 0,
            xmax : 3,
            ymax : 100,
            bgcolor : \"black\",
            bdcolor : borderColor,
            border : 1,
            relief : \"raised\",
            sensitive : ON+MOTION
	  };

	  ");

/* create the display window */

  execute("%scout
	   display "//str(wname)//"window =<"//str(wname)//"TitleBar/"//str(wname)//"disp/"//str(wname)//"HorizontalScrollBarLeftwidget/"//str(wname)//"HorizontalScrollBarRightwidget/"//str(wname)//"HorizontalScrollBarMain/"//str(wname)//"HorizontalScrollBarBack/"//str(wname)//"Back>;
	  ");

/* Now add the new display to the screen list display */

  temp = symboltext("model_screen");
  temp2= substr(temp,1,temp#-1);
  temp3 =strcat(" // ",wname,"window");
  temp4 = strcat(temp2,temp3,";");
  execute("model_screen is "//str(temp4)//" ");

/* now create the procedure which tracks the mouse movement in the window */

execute("
	proc motionin"//str(wname)//"dispwindow : "//str(wname)//"disp_mousePos
	{
	auto xco,yco;
        
  	xco = int("//str(wname)//"disp_mousePos[1] / (100.0/numberofranges)) + 1;
  	yco = int("//str(wname)//"disp_mousePos[2] / (100.0/numberofranges)) + 1;
  	  if ((xco<=displays["//str(winlist#)//"]#)&&(yco<=displays["//str(winlist#)//"][xco]#)) {
    		writeln(displays["//str(winlist#)//"][xco][yco],\" is the data number here\");
    		highlighted_house = displays["//str(winlist#)//"][xco][yco];
  	  } else {highlighted_house = 0;}
	}
       ");

/* now create the interface widget manipulation procedures */

/* Firstly - create the moving window bit */

execute("

	originalPos = [0,0];
	moving"//str(wname)//"Display = FALSE;

	proc "//str(wname)//"DisplayMove: "//str(wname)//"TitleBar_mousePos
   
	{
         
  	  if ("//str(wname)//"TitleBar_mouse!=@)
  	  {
            if (("//str(wname)//"TitleBar_mouse[2]==4)&&(moving"//str(wname)//"Display==FALSE))
            {
	      /* records where last clicked */
              originalPos[1] = "//str(wname)//"TitleBar_mouse[4];
              originalPos[2] = "//str(wname)//"TitleBar_mouse[5];
              moving"//str(wname)//"Display = TRUE;
            }
            else if (moving"//str(wname)//"Display)
            {
              "//str(wname)//"_base[1] = "//str(wname)//"_base[1] +("//str(wname)//"TitleBar_mousePos[1] -originalPos[1]);
              eager();
              "//str(wname)//"_base[2] = "//str(wname)//"_base[2] -("//str(wname)//"TitleBar_mousePos[2] -originalPos[2]);
              eager(); /* the vertical is different to the horizontal equation because */
              /* of the fact that DOnald and Scout reference in different directions */
              if ("//str(wname)//"TitleBar_mouse[2]==5) {moving"//str(wname)//"Display = FALSE;}
            }
          }
        }  

       ");

/* now the scrollbar movey bit */

execute("

	IN"//str(wname)//"MOVE = FALSE;
	moving"//str(wname)//"HorizontalScrollBarMain = FALSE;
	proc "//str(wname)//"MoveHorizontalMainBar : "//str(wname)//"HorizontalScrollBarMain_mousePos
         
	{
     
	auto s; /* will hold the temporary size variable */
 
 	if (IN"//str(wname)//"MOVE==FALSE)
 	{
  	  IN"//str(wname)//"MOVE = TRUE;
        
  	  if ("//str(wname)//"HorizontalScrollBarMain_mouse!=@)
  	  {  
    	    writeln(\"Moving main horizontal scroll bar...\","//str(wname)//"HorizontalScrollBarMain_mousePos);
    	    if (("//str(wname)//"HorizontalScrollBarMain_mouse[2]==4)&&(moving"//str(wname)//"HorizontalScrollBarMain==FALSE))
    	    {   
              originalPos[1] = "//str(wname)//"HorizontalScrollBarMain_mouse[4];
              originalPos[2] = "//str(wname)//"HorizontalScrollBarMain_mouse[5];
              moving"//str(wname)//"HorizontalScrollBarMain = TRUE;
            }
    	    else if (moving"//str(wname)//"HorizontalScrollBarMain)
    	    { writeln("//str(wname)//"HScrollBar_left,"//str(wname)//"HScrollBar_right);
              s = "//str(wname)//"HScrollBar_size;
	      "//str(wname)//"HScrollBar_left=max("//str(wname)//"HScrollBar_left+("//str(wname)//"HorizontalScrollBarMain_mousePos[1]-originalPos[1]),0);
              if ("//str(wname)//"HScrollBar_left+s>"//str(wname)//"width) {"//str(wname)//"HScrollBar_left="//str(wname)//"HScrollBar_right - s;}
              "//str(wname)//"HScrollBar_right = "//str(wname)//"HScrollBar_left + s;
              if ("//str(wname)//"HScrollBar_right<s) {"//str(wname)//"HScrollBar_right = s;}
	      if("//str(wname)//"HorizontalScrollBarMain_mouse[2]==5) {moving"//str(wname)//"HorizontalScrollBarMain=FALSE;} 
              eager();
    	    }
          }  
          IN"//str(wname)//"MOVE = FALSE;
        }  
	} 

       ");

/* moving widget stuff */

execute("
     
	moving"//str(wname)//"HorizontalLeftWidget = FALSE;
	proc "//str(wname)//"MoveHorizontalLeftWidget: "//str(wname)//"HorizontalScrollBarLeftwidget_mousePos
        
	{
  	  if ("//str(wname)//"HorizontalScrollBarLeftwidget_mouse!=@)
  	  {
    	    writeln(\"Moving "//str(wname)//" left widget...\","//str(wname)//"HorizontalScrollBarLeftwidget_mousePos);
    	    if (("//str(wname)//"HorizontalScrollBarLeftwidget_mouse[2]==4)&&(moving"//str(wname)//"HorizontalLeftWidget==FALSE))
            { 
              originalPos[1] = "//str(wname)//"HorizontalScrollBarLeftwidget_mouse[4];
              originalPos[2] = "//str(wname)//"HorizontalScrollBarLeftwidget_mouse[5];
              moving"//str(wname)//"HorizontalLeftWidget = TRUE;
            }
            else if (moving"//str(wname)//"HorizontalLeftWidget)
            {   
	      writeln("//str(wname)//"HScrollBar_left);
	      "//str(wname)//"HScrollBar_left=max(min("//str(wname)//"HScrollBar_left+"//str(wname)//"HorizontalScrollBarLeftwidget_mousePos[1]-originalPos[1],"//str(wname)//"HScrollBar_right-3),0);
              if ("//str(wname)//"HorizontalScrollBarLeftwidget_mouse[2]==5) {moving"//str(wname)//"HorizontalLeftWidget=FALSE;}
              eager();
            }
          } 
        } 

	");

execute("

	moving"//str(wname)//"HorizontalRightWidget = FALSE;
	proc "//str(wname)//"MoveHorizontalRightWidget : "//str(wname)//"HorizontalScrollBarRightwidget_mousePos
     
	{
  	  if ("//str(wname)//"HorizontalScrollBarRightwidget_mouse!=@)
  	  {     
    	    writeln(\"Moving "//str(wname)//" right widget...\","//str(wname)//"HorizontalScrollBarRightwidget_mousePos);
    	    if (("//str(wname)//"HorizontalScrollBarRightwidget_mouse[2]==4)&&(moving"//str(wname)//"HorizontalRightWidget==FALSE))
    	    {
              originalPos[1] = "//str(wname)//"HorizontalScrollBarRightwidget_mouse[4];
              originalPos[2] = "//str(wname)//"HorizontalScrollBarRightwidget_mouse[5];
              moving"//str(wname)//"HorizontalRightWidget = TRUE;
    	    }
    	    else if (moving"//str(wname)//"HorizontalRightWidget)
    	    { 
	      writeln("//str(wname)//"HScrollBar_right);
     	      "//str(wname)//"HScrollBar_right=min(max("//str(wname)//"HScrollBar_right+"//str(wname)//"HorizontalScrollBarRightwidget_mousePos[1]-originalPos[1],"//str(wname)//"HScrollBar_left+3),"//str(wname)//"width);
              if ("//str(wname)//"HorizontalScrollBarRightwidget_mouse[2]==5) {moving"//str(wname)//"HorizontalRightWidget=FALSE;}
              eager();
    	    }
          }
        }    
	");

}


/* this procedure assumes we have an empty screen and is passed the data list to
display, a list
containing the titles for each of the windows and the starting window default
sizes. The display is
created as a single step and the number of displays created is equal to the number
of elements in each
data list */
           
/* choice determines whether you add new fields to an already existing display, e.g you
have three fields and you enter a new list with n fields and the same number of records and
it adds new displays, or you add to the already existing set, i.e you have the same number
of fields with n records and these get added to existing displays */

proc displaylist
{
/* startcol and startrow indicate which cell in the spreadsheet is used to load the data
   from */
para l,titles,defwid,defhei,startcol,startrow,choice;
auto i,s,start;

/* work out how many windows are already displayed and start the new lot at the next one */


start = 1;
starts = strcat("win",str(start),"disp");
while (type(`starts`)!="@") {start++; starts = strcat("win",str(start),"disp");}
writeln(start);

if (choice==addrecords) {start=1;}
if (data#==0) {choice==addrecords;}


for (i=1; i<= titles#; i++) {append windowtitleslist,titles[i];}


/* create the windows */
if ((choice==addfields)||(data#==0))
{
  for (i=1; i<=l[1]#; i++) 
  {
    s = strcat("win",str(i+start-1));
    createwin(s,defwid,defhei,120,120+((i-1)*(20)),5,titles[i]);
  }  
}  
eager();

 if (choice==addrecords)
 {
 /* add the data items */
  for (i=1; i<=l#; i++)
  {
    autocalc = 0;
    adddataitem(l,i,start,choice);
    writeln("Data element ",i," of ",l#);
  }
 } else {adddataitem(l,1,start,addfields);}
autocalc = 1;
}

