
%scout
# meta-interaction: action by the modeller to change the
# state of the computer model e.g. in order to make more
# space on the screen, by relocating image of clock and
# by shrinking the clock image.

%scout
clockwinScale = 1;
clockwinPos = {10,10};

%donald

within clock {
	line noon2
	noon2 = [noon.1, noon.1+ (noon.2 - noon.1)*2]
}

%donald

# edge is the circle that defines the outer rim of the clock face
# adding inner circle can be construed as a designer's action

within clock {
	circle inner_edge
	real width_edge
	inner_edge = circle(centre, radius - width_edge)
 	width_edge = 20.0

# aesthetic issue of where to place the inner edge

	width_edge = 10.0
}

%eden
include("autotime.e");
/* this maintains a variable tnsecs that records number of seconds
	elapsed in real-time from an arbitrary initial time: demo by
	proc wtnsecs: tnsecs { writeln(tnsecs); }
*/

_clock_t is abs_time(tn) / 60;	/* integer division, so integer */

%eden
uk_time is tnsecs / 60;
japan_time is uk_time + 480;
_clock_t is japan_time;

clockspeed = 1;
_clock_t is abs_time(tn) / (60 / clockspeed);



